# Copyright (C) 1999  Jarra & Anna Voleynik
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

# Addendums and changes made by -dkap freely given back to Jarra & Anna
# Voleynik's Copyright. 

# pro_agent.cfg contains entries in the following format:
# PRO:<UDstate>:<process_name>:<severity> 
#eg PRO:UP:sshd:2
#   PRO:DOWN:ftpd:2

# point to the directory where emsg.sh wrapper for emsg1 resides
EMSGSHDIR=/usr/local/bin  

# ps output
TMPFILE=/tmp/ps.out

ps axw  > $TMPFILE
oldIFS=$IFS 
IFS='
'

for line in `cat pro_agent.cfg  | egrep '^PRO:'` 
do
    IFS=$oldIFS

    UDSTATE=`echo $line | cut -d: -f 2`
    PROC=`echo $line | cut -d: -f 3`
    SEV=`echo $line | cut -d: -f 4`

    # get a list of processes

    if [ $UDSTATE = "UP" ];then 
        if [ -z "`egrep "$PROC" $TMPFILE | grep -v grep`" ];then
            $EMSGSHDIR/emsg.sh $SEV /OS/PRO/UP "$PROC is missing"
        fi
     else 
        if [ "`egrep "$PROC" $TMPFILE | grep -v grep`" ];then
            $EMSGSHDIR/emsg.sh $SEV /OS/PRO/DOWN "$PROC is there"
        fi
    fi
done

